/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var Rt=Object.create;var P=Object.defineProperty,Lt=Object.defineProperties,Ut=Object.getOwnPropertyDescriptor,Gt=Object.getOwnPropertyDescriptors,Vt=Object.getOwnPropertyNames,we=Object.getOwnPropertySymbols,Ht=Object.getPrototypeOf,Te=Object.prototype.hasOwnProperty,Wt=Object.prototype.propertyIsEnumerable;var xe=(e,t,r)=>t in e?P(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,m=(e,t)=>{for(var r in t||(t={}))Te.call(t,r)&&xe(e,r,t[r]);if(we)for(var r of we(t))Wt.call(t,r)&&xe(e,r,t[r]);return e},U=(e,t)=>Lt(e,Gt(t));var G=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),Jt=(e,t)=>{for(var r in t)P(e,r,{get:t[r],enumerable:!0})},Ee=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let o of Vt(t))!Te.call(e,o)&&o!==r&&P(e,o,{get:()=>t[o],enumerable:!(n=Ut(t,o))||n.enumerable});return e};var V=(e,t,r)=>(r=e!=null?Rt(Ht(e)):{},Ee(t||!e||!e.__esModule?P(r,"default",{value:e,enumerable:!0}):r,e)),Qt=e=>Ee(P({},"__esModule",{value:!0}),e);var De=G((Mi,Pe)=>{var Ce=1/0,Me=9007199254740991,qt=17976931348623157e292,$e=0/0,Xt="[object Arguments]",Zt="[object Function]",Yt="[object GeneratorFunction]",zt="[object String]",er="[object Symbol]",tr=/^\s+|\s+$/g,rr=/^[-+]0x[0-9a-f]+$/i,nr=/^0b[01]+$/i,ir=/^0o[0-7]+$/i,ar=/^(?:0|[1-9]\d*)$/,or=parseInt;function sr(e,t){for(var r=-1,n=e?e.length:0,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}function ur(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}function cr(e,t,r){if(t!==t)return ur(e,fr,r);for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}function fr(e){return e!==e}function pr(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function lr(e,t){return sr(t,function(r){return e[r]})}function yr(e,t){return function(r){return e(t(r))}}var H=Object.prototype,ie=H.hasOwnProperty,W=H.toString,hr=H.propertyIsEnumerable,gr=yr(Object.keys,Object),br=Math.max;function dr(e,t){var r=Ie(e)||jr(e)?pr(e.length,String):[],n=r.length,o=!!n;for(var i in e)(t||ie.call(e,i))&&!(o&&(i=="length"||Ar(i,n)))&&r.push(i);return r}function mr(e){if(!Or(e))return gr(e);var t=[];for(var r in Object(e))ie.call(e,r)&&r!="constructor"&&t.push(r);return t}function Ar(e,t){return t=t==null?Me:t,!!t&&(typeof e=="number"||ar.test(e))&&e>-1&&e%1==0&&e<t}function Or(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||H;return e===r}function _r(e,t,r,n){e=ae(e)?e:Mr(e),r=r&&!n?Er(r):0;var o=e.length;return r<0&&(r=br(o+r,0)),wr(e)?r<=o&&e.indexOf(t,r)>-1:!!o&&cr(e,t,r)>-1}function jr(e){return kr(e)&&ie.call(e,"callee")&&(!hr.call(e,"callee")||W.call(e)==Xt)}var Ie=Array.isArray;function ae(e){return e!=null&&Sr(e.length)&&!vr(e)}function kr(e){return oe(e)&&ae(e)}function vr(e){var t=ne(e)?W.call(e):"";return t==Zt||t==Yt}function Sr(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=Me}function ne(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function oe(e){return!!e&&typeof e=="object"}function wr(e){return typeof e=="string"||!Ie(e)&&oe(e)&&W.call(e)==zt}function xr(e){return typeof e=="symbol"||oe(e)&&W.call(e)==er}function Tr(e){if(!e)return e===0?e:0;if(e=Cr(e),e===Ce||e===-Ce){var t=e<0?-1:1;return t*qt}return e===e?e:0}function Er(e){var t=Tr(e),r=t%1;return t===t?r?t-r:t:0}function Cr(e){if(typeof e=="number")return e;if(xr(e))return $e;if(ne(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=ne(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=e.replace(tr,"");var r=nr.test(e);return r||ir.test(e)?or(e.slice(2),r?2:8):rr.test(e)?$e:+e}function $r(e){return ae(e)?dr(e):mr(e)}function Mr(e){return e?lr(e,$r(e)):[]}Pe.exports=_r});var Ke=G((Bi,Ne)=>{var Ir=typeof global=="object"&&global&&global.Object===Object&&global,Pr=typeof self=="object"&&self&&self.Object===Object&&self,Dr=Ir||Pr||Function("return this")(),Br=Dr.isFinite;function Fr(e){return typeof e=="number"&&Br(e)}Ne.exports=Fr});var xt=G((F,E)=>{var Nr=200,Ze="__lodash_hash_undefined__",Ye=9007199254740991,he="[object Arguments]",Kr="[object Array]",ze="[object Boolean]",et="[object Date]",Rr="[object Error]",ge="[object Function]",tt="[object GeneratorFunction]",Q="[object Map]",rt="[object Number]",be="[object Object]",Re="[object Promise]",nt="[object RegExp]",q="[object Set]",it="[object String]",at="[object Symbol]",ue="[object WeakMap]",ot="[object ArrayBuffer]",X="[object DataView]",st="[object Float32Array]",ut="[object Float64Array]",ct="[object Int8Array]",ft="[object Int16Array]",pt="[object Int32Array]",lt="[object Uint8Array]",yt="[object Uint8ClampedArray]",ht="[object Uint16Array]",gt="[object Uint32Array]",Lr=/[\\^$.*+?()[\]{}|]/g,Ur=/\w*$/,Gr=/^\[object .+?Constructor\]$/,Vr=/^(?:0|[1-9]\d*)$/,y={};y[he]=y[Kr]=y[ot]=y[X]=y[ze]=y[et]=y[st]=y[ut]=y[ct]=y[ft]=y[pt]=y[Q]=y[rt]=y[be]=y[nt]=y[q]=y[it]=y[at]=y[lt]=y[yt]=y[ht]=y[gt]=!0;y[Rr]=y[ge]=y[ue]=!1;var Hr=typeof global=="object"&&global&&global.Object===Object&&global,Wr=typeof self=="object"&&self&&self.Object===Object&&self,_=Hr||Wr||Function("return this")(),bt=typeof F=="object"&&F&&!F.nodeType&&F,Le=bt&&typeof E=="object"&&E&&!E.nodeType&&E,Jr=Le&&Le.exports===bt;function Qr(e,t){return e.set(t[0],t[1]),e}function qr(e,t){return e.add(t),e}function Xr(e,t){for(var r=-1,n=e?e.length:0;++r<n&&t(e[r],r,e)!==!1;);return e}function Zr(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}function dt(e,t,r,n){var o=-1,i=e?e.length:0;for(n&&i&&(r=e[++o]);++o<i;)r=t(r,e[o],o,e);return r}function Yr(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function zr(e,t){return e==null?void 0:e[t]}function mt(e){var t=!1;if(e!=null&&typeof e.toString!="function")try{t=!!(e+"")}catch(r){}return t}function Ue(e){var t=-1,r=Array(e.size);return e.forEach(function(n,o){r[++t]=[o,n]}),r}function de(e,t){return function(r){return e(t(r))}}function Ge(e){var t=-1,r=Array(e.size);return e.forEach(function(n){r[++t]=n}),r}var en=Array.prototype,tn=Function.prototype,Z=Object.prototype,se=_["__core-js_shared__"],Ve=function(){var e=/[^.]+$/.exec(se&&se.keys&&se.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),At=tn.toString,k=Z.hasOwnProperty,Y=Z.toString,rn=RegExp("^"+At.call(k).replace(Lr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),He=Jr?_.Buffer:void 0,We=_.Symbol,Je=_.Uint8Array,nn=de(Object.getPrototypeOf,Object),an=Object.create,on=Z.propertyIsEnumerable,sn=en.splice,Qe=Object.getOwnPropertySymbols,un=He?He.isBuffer:void 0,cn=de(Object.keys,Object),ce=M(_,"DataView"),N=M(_,"Map"),fe=M(_,"Promise"),pe=M(_,"Set"),le=M(_,"WeakMap"),K=M(Object,"create"),fn=T(ce),pn=T(N),ln=T(fe),yn=T(pe),hn=T(le),qe=We?We.prototype:void 0,Xe=qe?qe.valueOf:void 0;function x(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function gn(){this.__data__=K?K(null):{}}function bn(e){return this.has(e)&&delete this.__data__[e]}function dn(e){var t=this.__data__;if(K){var r=t[e];return r===Ze?void 0:r}return k.call(t,e)?t[e]:void 0}function mn(e){var t=this.__data__;return K?t[e]!==void 0:k.call(t,e)}function An(e,t){var r=this.__data__;return r[e]=K&&t===void 0?Ze:t,this}x.prototype.clear=gn;x.prototype.delete=bn;x.prototype.get=dn;x.prototype.has=mn;x.prototype.set=An;function j(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function On(){this.__data__=[]}function _n(e){var t=this.__data__,r=z(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():sn.call(t,r,1),!0}function jn(e){var t=this.__data__,r=z(t,e);return r<0?void 0:t[r][1]}function kn(e){return z(this.__data__,e)>-1}function vn(e,t){var r=this.__data__,n=z(r,e);return n<0?r.push([e,t]):r[n][1]=t,this}j.prototype.clear=On;j.prototype.delete=_n;j.prototype.get=jn;j.prototype.has=kn;j.prototype.set=vn;function C(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Sn(){this.__data__={hash:new x,map:new(N||j),string:new x}}function wn(e){return ee(this,e).delete(e)}function xn(e){return ee(this,e).get(e)}function Tn(e){return ee(this,e).has(e)}function En(e,t){return ee(this,e).set(e,t),this}C.prototype.clear=Sn;C.prototype.delete=wn;C.prototype.get=xn;C.prototype.has=Tn;C.prototype.set=En;function $(e){this.__data__=new j(e)}function Cn(){this.__data__=new j}function $n(e){return this.__data__.delete(e)}function Mn(e){return this.__data__.get(e)}function In(e){return this.__data__.has(e)}function Pn(e,t){var r=this.__data__;if(r instanceof j){var n=r.__data__;if(!N||n.length<Nr-1)return n.push([e,t]),this;r=this.__data__=new C(n)}return r.set(e,t),this}$.prototype.clear=Cn;$.prototype.delete=$n;$.prototype.get=Mn;$.prototype.has=In;$.prototype.set=Pn;function Dn(e,t){var r=Ae(e)||ai(e)?Yr(e.length,String):[],n=r.length,o=!!n;for(var i in e)(t||k.call(e,i))&&!(o&&(i=="length"||ti(i,n)))&&r.push(i);return r}function Ot(e,t,r){var n=e[t];(!(k.call(e,t)&&vt(n,r))||r===void 0&&!(t in e))&&(e[t]=r)}function z(e,t){for(var r=e.length;r--;)if(vt(e[r][0],t))return r;return-1}function Bn(e,t){return e&&_t(t,Oe(t),e)}function ye(e,t,r,n,o,i,a){var c;if(n&&(c=i?n(e,o,i,a):n(e)),c!==void 0)return c;if(!te(e))return e;var l=Ae(e);if(l){if(c=Yn(e),!t)return qn(e,c)}else{var b=w(e),A=b==ge||b==tt;if(si(e))return Un(e,t);if(b==be||b==he||A&&!i){if(mt(e))return i?e:{};if(c=zn(A?{}:e),!t)return Xn(e,Bn(c,e))}else{if(!y[b])return i?e:{};c=ei(e,b,ye,t)}}a||(a=new $);var f=a.get(e);if(f)return f;if(a.set(e,c),!l)var s=r?Zn(e):Oe(e);return Xr(s||e,function(h,p){s&&(p=h,h=e[p]),Ot(c,p,ye(h,t,r,n,p,e,a))}),c}function Fn(e){return te(e)?an(e):{}}function Nn(e,t,r){var n=t(e);return Ae(e)?n:Zr(n,r(e))}function Kn(e){return Y.call(e)}function Rn(e){if(!te(e)||ni(e))return!1;var t=wt(e)||mt(e)?rn:Gr;return t.test(T(e))}function Ln(e){if(!kt(e))return cn(e);var t=[];for(var r in Object(e))k.call(e,r)&&r!="constructor"&&t.push(r);return t}function Un(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}function me(e){var t=new e.constructor(e.byteLength);return new Je(t).set(new Je(e)),t}function Gn(e,t){var r=t?me(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}function Vn(e,t,r){var n=t?r(Ue(e),!0):Ue(e);return dt(n,Qr,new e.constructor)}function Hn(e){var t=new e.constructor(e.source,Ur.exec(e));return t.lastIndex=e.lastIndex,t}function Wn(e,t,r){var n=t?r(Ge(e),!0):Ge(e);return dt(n,qr,new e.constructor)}function Jn(e){return Xe?Object(Xe.call(e)):{}}function Qn(e,t){var r=t?me(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}function qn(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}function _t(e,t,r,n){r||(r={});for(var o=-1,i=t.length;++o<i;){var a=t[o],c=n?n(r[a],e[a],a,r,e):void 0;Ot(r,a,c===void 0?e[a]:c)}return r}function Xn(e,t){return _t(e,jt(e),t)}function Zn(e){return Nn(e,Oe,jt)}function ee(e,t){var r=e.__data__;return ri(t)?r[typeof t=="string"?"string":"hash"]:r.map}function M(e,t){var r=zr(e,t);return Rn(r)?r:void 0}var jt=Qe?de(Qe,Object):fi,w=Kn;(ce&&w(new ce(new ArrayBuffer(1)))!=X||N&&w(new N)!=Q||fe&&w(fe.resolve())!=Re||pe&&w(new pe)!=q||le&&w(new le)!=ue)&&(w=function(e){var t=Y.call(e),r=t==be?e.constructor:void 0,n=r?T(r):void 0;if(n)switch(n){case fn:return X;case pn:return Q;case ln:return Re;case yn:return q;case hn:return ue}return t});function Yn(e){var t=e.length,r=e.constructor(t);return t&&typeof e[0]=="string"&&k.call(e,"index")&&(r.index=e.index,r.input=e.input),r}function zn(e){return typeof e.constructor=="function"&&!kt(e)?Fn(nn(e)):{}}function ei(e,t,r,n){var o=e.constructor;switch(t){case ot:return me(e);case ze:case et:return new o(+e);case X:return Gn(e,n);case st:case ut:case ct:case ft:case pt:case lt:case yt:case ht:case gt:return Qn(e,n);case Q:return Vn(e,n,r);case rt:case it:return new o(e);case nt:return Hn(e);case q:return Wn(e,n,r);case at:return Jn(e)}}function ti(e,t){return t=t==null?Ye:t,!!t&&(typeof e=="number"||Vr.test(e))&&e>-1&&e%1==0&&e<t}function ri(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}function ni(e){return!!Ve&&Ve in e}function kt(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||Z;return e===r}function T(e){if(e!=null){try{return At.call(e)}catch(t){}try{return e+""}catch(t){}}return""}function ii(e){return ye(e,!0,!0)}function vt(e,t){return e===t||e!==e&&t!==t}function ai(e){return oi(e)&&k.call(e,"callee")&&(!on.call(e,"callee")||Y.call(e)==he)}var Ae=Array.isArray;function St(e){return e!=null&&ui(e.length)&&!wt(e)}function oi(e){return ci(e)&&St(e)}var si=un||pi;function wt(e){var t=te(e)?Y.call(e):"";return t==ge||t==tt}function ui(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=Ye}function te(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function ci(e){return!!e&&typeof e=="object"}function Oe(e){return St(e)?Dn(e):Ln(e)}function fi(){return[]}function pi(){return!1}E.exports=ii});var It=G((R,I)=>{var li="[object Date]",yi=typeof global=="object"&&global&&global.Object===Object&&global,Mt=typeof R=="object"&&R&&!R.nodeType&&R,Tt=Mt&&typeof I=="object"&&I&&!I.nodeType&&I,hi=Tt&&Tt.exports===Mt,Et=hi&&yi.process,Ct=function(){try{return Et&&Et.binding("util")}catch(e){}}(),$t=Ct&&Ct.isDate;function gi(e){return function(t){return e(t)}}var bi=Object.prototype,di=bi.toString;function mi(e){return Oi(e)&&di.call(e)==li}var Ai=$t?gi($t):mi;function Oi(e){return!!e&&typeof e=="object"}I.exports=Ai});var Ci={};Jt(Ci,{defaults:()=>Kt,generateAst:()=>Ei,version:()=>xi});var Bt=V(De(),1);function d(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function D(e){return typeof e=="string"}function Be(e){return Number.isFinite(e)}function J(e){return typeof e=="boolean"}function B(e){return e!=null}function Fe(e,t){return d(e)&&D(t)&&Object.prototype.hasOwnProperty.call(e,t)}function O(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:d(e)?!!Object.keys(e).length:typeof e=="number"}var ve=V(Ke(),1),u=V(xt(),1),L=V(It(),1);function _e(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var je=new Map,Pt=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},_i=(e,t)=>{t=m({caseSensitive:!1},t);let r=e+JSON.stringify(t);if(je.has(r))return je.get(r);let n=e[0]==="!";n&&(e=e.slice(1)),e=_e(e).replace(/\\\*/g,"[\\s\\S]*");let o=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return o.negated=n,je.set(r,o),o},ji=(e,t,r,n)=>{if(e=Pt(e,"inputs"),t=Pt(t,"patterns"),t.length===0)return[];t=t.map(a=>_i(a,r));let{allPatterns:o}=r||{},i=[];for(let a of e){let c,l=[...t].fill(!1);for(let[b,A]of t.entries())if(A.test(a)&&(l[b]=!0,c=!A.negated,!c))break;if(!(c===!1||c===void 0&&t.some(b=>!b.negated)||o&&l.some((b,A)=>!b&&!t[A].negated))&&(i.push(a),n))break}return i};function re(e,t,r){return ji(e,t,r,!0).length>0}var ki={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function ke(e,t,r){if(!e.length||!t.length)return!1;let n=m(m({},ki),r),o=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?o.some(i=>re(i,t,{caseSensitive:n.caseSensitive})):n.arrayVsArrayAllMustBeFound==="any"?t.some(i=>o.some(a=>re(a,i,{caseSensitive:n.caseSensitive}))):t.every(i=>o.some(a=>re(a,i,{caseSensitive:n.caseSensitive})))}var v=Array.isArray;function Dt(e){return!!e&&e.some(t=>typeof t=="string")}function vi(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(r=>Object.keys(t).includes(r))||Object.keys(t).every(r=>Object.keys(e).includes(r))}function g(e){return e===null?"null":(0,L.default)(e)?"date":d(e)?"object":v(e)?"array":typeof e}var Si={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function S(e,t,r,n){var A;let o;if(n.useNullAsExplicitFalse&&(t===null||r===null))return typeof n.cb=="function"?n.cb(t,r,null,{path:e.path,key:e.key,type:e.type}):null;let i=v(t)||d(t)?(0,u.default)(t):t,a=v(r)||d(r)?(0,u.default)(r):r,c;n.ignoreEverything?c=i:n.hardMergeEverything&&(c=a);let l=n.hardMergeEverything||n.ignoreEverything;if(v(i))if(O(i))if(v(a)&&O(a)){if(n.mergeArraysContainingStringsToBeEmpty&&(Dt(i)||Dt(a))){let s=l?c:[];return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:o,key:e.key,type:e.type}):s}if(n.hardArrayConcat){let s=l?c:i.concat(a);return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=[];for(let s=0,h=Math.max(i.length,a.length);s<h;s++)o=(A=e.path)!=null&&A.length?`${e.path}.${s}`:`${s}`,d(i[s])&&d(a[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&vi(i[s],a[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?f.push(S({path:o,key:e.key,type:[g(i),g(a)]},i[s],a[s],n)):n.oneToManyArrayObjectMerge&&(i.length===1||a.length===1)?f.push(i.length===1?S({path:o,key:e.key,type:[g(i),g(a)]},i[0],a[s],n):S({path:o,key:e.key,type:[g(i),g(a)]},i[s],a[0],n)):n.concatInsteadOfMerging?(s<i.length&&f.push(i[s]),s<a.length&&f.push(a[s])):(s<i.length&&f.push(i[s]),s<a.length&&!(0,Bt.default)(i,a[s])&&f.push(a[s]));n.dedupeStringsInArrayValues&&f.every(s=>D(s))&&(f=[...new Set(f)].sort()),i=(0,u.default)(f)}else{let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:o,key:e.key,type:e.type}):f}else{if(O(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:o,key:e.key,type:e.type}):f}else if(d(i)){if(O(i)){if(v(a)){if(O(a)){let p=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),p,{path:o,key:e.key,type:e.type}):p}let h=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),h,{path:o,key:e.key,type:e.type}):h}if(d(a)){Object.keys(a).forEach(p=>{var Se;o=(Se=e.path)!=null&&Se.length?`${e.path}.${p}`:`${p}`,Fe(i,p)?ke(p,n.ignoreKeys)?i[p]=S({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],U(m({},n),{ignoreEverything:!0})):ke(p,n.hardMergeKeys)?i[p]=S({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],U(m({},n),{hardMergeEverything:!0})):ke(p,n.hardArrayConcatKeys)?i[p]=S({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],U(m({},n),{hardArrayConcat:!0})):i[p]=S({path:o,key:p,type:[g(i[p]),g(a[p])]},i[p],a[p],n):i[p]=a[p]});let h=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),h,{path:e.path,key:e.key,type:e.type}):i}let s=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(v(a)||d(a)||O(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if((0,L.default)(i)){if((0,ve.default)(+i)){if((0,L.default)(a)){if((0,ve.default)(+a)){let p=l?c:i>a?i:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),p,{path:e.path,key:e.key,type:e.type}):p}let h=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?c:a||i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if((0,L.default)(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(D(i)){if(O(i)){if((v(a)||d(a)||D(a))&&O(a)){let h=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(B(a)&&!J(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(Be(i)){if(O(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(J(i)){if(J(a)){if(n.mergeBoolsUsingOrNotAnd){let h=l?c:i||a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?c:i&&a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(B(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(i===null){if(B(a)){let s=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else{let f=l?c:a;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}let b=l?c:i;return typeof n.cb=="function"?n.cb((0,u.default)(t),(0,u.default)(r),b,{path:e.path,key:e.key,type:e.type}):b}function Ft(e,t,r){var o,i;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");if(B(r)&&!d(r))throw new TypeError(`object-merge-advanced/mergeAdvanced(): [THROW_ID_02] The optional options object should be a plain object, currently it's ${JSON.stringify(r,null,4)} (type ${typeof r})`);let n=m(m({},Si),r);return typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),(o=n==null?void 0:n.hardMergeKeys)!=null&&o.includes("*")&&(n.hardMergeEverything=!0),(i=n==null?void 0:n.ignoreKeys)!=null&&i.includes("*")&&(n.ignoreEverything=!0),S({key:null,path:"",type:[g(e),g(t)]},e,t,n)}var Nt="4.0.11";var xi=Nt,Kt={dedupe:!0};function Ti(e){return Object.keys(e).sort().reduce((t,r)=>(t[r]=e[r],t),{})}function Ei(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let r=m(m({},Kt),t),n={};return e.forEach(o=>{let i=null;for(let a=o.length;a--;)i={[o[a]]:[i]};n=Ft(n,i,{concatInsteadOfMerging:!r.dedupe})}),Ti(n)}return Qt(Ci);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.4.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
